Ruby - Bug #4438

rescue args type check omitted
02/24/2011 07:10 PM - nahi (Hiroshi Nakamura)

Status: Closed

Priority: Normal

Assignee: ko1 (Koichi Sasada)

Target version: 2.0.0

ruby -v: - Backport:
Description

=begin

Rescue arg must be class or module in 1.8. 1.9 looks to ignore when it's not a class or module.
Is this expected behavior?

0% ruby -ve 'begin; raise; rescue nil; end'

ruby 1.9.3dev (2011-02-23 trunk 30945) [x86_64-linux]
-e:1:in *': unhandled exception

1% ruby187 -ve 'begin; raise; rescue nil; end'

ruby 1.8.7 (2010-12-23 patchlevel 330) [x86_64-linux]

-e:1: class or module required for rescue clause (TypeError)

=end

Related issues:
Related to Ruby - Feature #19620: allow non-module rescue filters that implem... Open

Associated revisions

Revision 93b6f8d6195564d0884ee00f536a951f4c26288¢ - 08/08/2012 07:52 AM - ko1 (Koichi Sasada)

compile.c, insns.def (checkmatch):

remove checkincludearray instruction and

add new instruction checkmatch.

This change is to solve

[Bug #4438] "rescue args type check omitted".
iseq.c: increment ISEQ_MAJOR_VERSION because removal of
checkincludearray instruction.

e vm_core.h: add several definitions for

the checkmatch instruction.

vm_insnhelper.c (check_match): added.

e bootstraptest/test_exception.rb: add a test.
test/ruby/test_exception.rb: ditto.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@36658 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 93b6f8d6 - 08/08/2012 07:52 AM - ko1 (Koichi Sasada)

compile.c, insns.def (checkmatch):

remove checkincludearray instruction and

add new instruction checkmatch.

This change is to solve

[Bug #4438] "rescue args type check omitted".
iseq.c: increment ISEQ_MAJOR_VERSION because removal of
checkincludearray instruction.

e vm_core.h: add several definitions for

the checkmatch instruction.

vm_insnhelper.c (check_match): added.

® bootstraptest/test_exception.rb: add a test.
test/ruby/test_exception.rb: ditto.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@36658 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History
#1 - 02/25/2011 12:23 AM - matz (Yukihiro Matsumoto)
- ruby -v changed from ruby 1.9.3dev (2011-02-23 trunk 30945) [x86_64-linux] to -

=begin
Hi,

In message "Re: [ruby-core:35364] [Ruby 1.9 - Bug #4438] [Open] rescue args type check omitted"
on Thu, 24 Feb 2011 19:07:03 +0900, Hiroshi NAKAMURA nakahiro@gmail.com writes:

|Rescue arg must be class or module in 1.8. 1.9 looks to ignore when it's not a class or module.
|Is this expected behavior?

No, it should check as 1.8 does.
matz.

=end

#2 - 06/26/2011 06:11 PM - naruse (Yui NARUSE)
- Status changed from Open to Assigned

- Assignee set to ko1 (Koichi Sasada)

#3 - 06/26/2011 06:43 PM - nahi (Hiroshi Nakamura)

- Target version set to 1.9.3

#4 - 06/27/2011 12:20 AM - adgar (Michael Edgar)

=begin

Right now, the current behavior simply calls (({===})) on whichever handlers are listed; this

results in interesting possibilities ((<I briefly explored on my blog|URL:http://carboni.ca/blog/p/Ruby-Did-You-Know-That-2-Exception-Handling>)). |
had assumed it was intended. One

could construct interesting possibilities which this behavior: raise an integer, and rescue with

a proc which checks if the integer is nonzero, for example.

Are we sure we don't want this more general behavior? | personally find the flexibility attractive.
=end

#5 - 07/10/2011 02:58 PM - ko1 (Koichi Sasada)
- Target version changed from 1.9.3 to 2.0.0

Let's discuss spec and impl. before 1.9.4 release.

#6 - 08/06/2012 10:33 PM - nobu (Nobuyoshi Nakada)

- File 0001-check-rescue-clause-arguments.patch added

Patch attached.

#7 - 08/08/2012 04:52 PM - ko1 (Koichi Sasada)
- Status changed from Assigned to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r36658.
Hiroshi, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.
May Ruby be with you.

e compile.c, insns.def (checkmatch):

remove checkincludearray instruction and

add new instruction checkmatch.

This change is to solve

[Bug #4438] "rescue args type check omitted".

iseq.c: increment ISEQ_MAJOR_VERSION because removal of
checkincludearray instruction.

vm_core.h: add several definitions for

the checkmatch instruction.
e vm_insnhelper.c (check_match): added.
e bootstraptest/test_exception.rb: add a test.
¢ test/ruby/test_exception.rb: ditto.
#8 - 04/27/2023 05:17 PM - byroot (Jean Boussier)

- Related to Feature #19620: allow non-module rescue filters that implement the === opertor added

Files

0001-check-rescue-clause-arguments.patch 6.27 KB 08/06/2012 nobu (Nobuyoshi Nakada)
